doctrine:
    dbal:
        url: '%env(resolve:DATABASE_URL)%'

        # Required for DAMA doctrine test bundle
        use_savepoints: true

        # IMPORTANT: You MUST configure your server version,
        # either here or in the DATABASE_URL env var (see .env file)

        types:
            # UTC datetimes
            datetime:
                class: App\Doctrine\Types\UTCDateTimeType
            date:
                class: App\Doctrine\Types\UTCDateTimeType

            datetime_immutable:
                class: App\Doctrine\Types\UTCDateTimeImmutableType
            date_immutable:
                class: App\Doctrine\Types\UTCDateTimeImmutableType

            big_decimal:
                class: App\Doctrine\Types\BigDecimalType
            tinyint:
                class: App\Doctrine\Types\TinyIntType

            # This was removed in doctrine/orm 4.0 but we need it for the WebauthnKey entity
            array:
                class: App\Doctrine\Types\ArrayType
        
        schema_filter: ~^(?!internal)~
        # Only enable this when needed
        profiling_collect_backtrace: false

    orm:
        auto_generate_proxy_classes: true
        enable_lazy_ghost_objects: true
        report_fields_where_declared: true
        validate_xml_mapping: true
        naming_strategy: doctrine.orm.naming_strategy.underscore_number_aware
        auto_mapping: true
        controller_resolver:
            auto_mapping: true
        mappings:
            App:
                type: attribute
                is_bundle: false
                dir: '%kernel.project_dir%/src/Entity'
                prefix: 'App\Entity'
                alias: App

        dql:
            string_functions:
                regexp: App\Doctrine\Functions\Regexp
                field:  DoctrineExtensions\Query\Mysql\Field
                field2: App\Doctrine\Functions\Field2
                natsort: App\Doctrine\Functions\Natsort
                array_position: App\Doctrine\Functions\ArrayPosition

when@test:
    doctrine:
        dbal:
            # "TEST_TOKEN" is typically set by ParaTest
            dbname_suffix: '_test%env(default::TEST_TOKEN)%'

when@prod: &prod
    doctrine:
        orm:
            auto_generate_proxy_classes: false
            proxy_dir: '%kernel.build_dir%/doctrine/orm/Proxies'
            query_cache_driver:
                type: pool
                pool: doctrine.system_cache_pool
            result_cache_driver:
                type: pool
                pool: doctrine.result_cache_pool

    framework:
        cache:
            pools:
                doctrine.result_cache_pool:
                    adapter: cache.app
                doctrine.system_cache_pool:
                    adapter: cache.system

when@docker: *prod
